# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

from MLLPStreamingClient import mllp_streaming_pb2 as MLLPStreamingClient_dot_mllp__streaming__pb2
from google.protobuf import empty_pb2 as google_dot_protobuf_dot_empty__pb2


class MLLPStreamingStub(object):
    """*
    Logical steps to follow to use the service are:
    <ol>
    <li>Call <i>GetAuthToken</i> with your TTP API credentials to get a valid auth token. This token has to be provided to the rest of rpc methods as metadata with the following header key: "x-mllp-auth-token". </li>
    <li>Call <i>GetTranscribeSystemsInfo</i>, to obtain a list of currently available transcription (ASR) systems.</li>
    <li>Call <i>Transcribe</i> sending a continuous audio stream.</li>
    </ol>
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.GetAuthToken = channel.unary_unary(
                '/MLLPStreaming/GetAuthToken',
                request_serializer=MLLPStreamingClient_dot_mllp__streaming__pb2.AuthTokenRequest.SerializeToString,
                response_deserializer=MLLPStreamingClient_dot_mllp__streaming__pb2.AuthTokenResponse.FromString,
                )
        self.GetTranscribeSystemsInfo = channel.unary_stream(
                '/MLLPStreaming/GetTranscribeSystemsInfo',
                request_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
                response_deserializer=MLLPStreamingClient_dot_mllp__streaming__pb2.TranscribeSystemsInfoResponse.FromString,
                )
        self.Transcribe = channel.stream_stream(
                '/MLLPStreaming/Transcribe',
                request_serializer=MLLPStreamingClient_dot_mllp__streaming__pb2.TranscribeRequest.SerializeToString,
                response_deserializer=MLLPStreamingClient_dot_mllp__streaming__pb2.TranscribeResponse.FromString,
                )
        self.AddASRNode = channel.unary_unary(
                '/MLLPStreaming/AddASRNode',
                request_serializer=MLLPStreamingClient_dot_mllp__streaming__pb2.AddASRNodeRequest.SerializeToString,
                response_deserializer=MLLPStreamingClient_dot_mllp__streaming__pb2.AddASRNodeResponse.FromString,
                )
        self.ListASRNodes = channel.unary_stream(
                '/MLLPStreaming/ListASRNodes',
                request_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
                response_deserializer=MLLPStreamingClient_dot_mllp__streaming__pb2.ListASRNodesResponse.FromString,
                )
        self.RemoveASRNode = channel.unary_unary(
                '/MLLPStreaming/RemoveASRNode',
                request_serializer=MLLPStreamingClient_dot_mllp__streaming__pb2.RemoveASRNodeRequest.SerializeToString,
                response_deserializer=MLLPStreamingClient_dot_mllp__streaming__pb2.RemoveASRNodeResponse.FromString,
                )


class MLLPStreamingServicer(object):
    """*
    Logical steps to follow to use the service are:
    <ol>
    <li>Call <i>GetAuthToken</i> with your TTP API credentials to get a valid auth token. This token has to be provided to the rest of rpc methods as metadata with the following header key: "x-mllp-auth-token". </li>
    <li>Call <i>GetTranscribeSystemsInfo</i>, to obtain a list of currently available transcription (ASR) systems.</li>
    <li>Call <i>Transcribe</i> sending a continuous audio stream.</li>
    </ol>
    """

    def GetAuthToken(self, request, context):
        """Get a valid auth token to perform furter rpc requests.
        Without a valid auth token, all other rpc calls with return a PERMISSION_DENIED status code error.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def GetTranscribeSystemsInfo(self, request, context):
        """Get information about all available streaming transcription (ASR) systems. Requires a valid auth token, supplied as metadata.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Transcribe(self, request_iterator, context):
        """Transcribe a stream of raw audio samples using a streaming transcription (ASR) system. Requires a valid auth token, supplied as metadata.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def AddASRNode(self, request, context):
        """Admin method: add an ASR Server. Requires a valid auth token, supplied as metadata.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def ListASRNodes(self, request, context):
        """Admin method: list ASR Servers. Requires a valid auth token, supplied as metadata.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def RemoveASRNode(self, request, context):
        """Admin method: remove an ASR Server. Requires a valid auth token, supplied as metadata.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_MLLPStreamingServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'GetAuthToken': grpc.unary_unary_rpc_method_handler(
                    servicer.GetAuthToken,
                    request_deserializer=MLLPStreamingClient_dot_mllp__streaming__pb2.AuthTokenRequest.FromString,
                    response_serializer=MLLPStreamingClient_dot_mllp__streaming__pb2.AuthTokenResponse.SerializeToString,
            ),
            'GetTranscribeSystemsInfo': grpc.unary_stream_rpc_method_handler(
                    servicer.GetTranscribeSystemsInfo,
                    request_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
                    response_serializer=MLLPStreamingClient_dot_mllp__streaming__pb2.TranscribeSystemsInfoResponse.SerializeToString,
            ),
            'Transcribe': grpc.stream_stream_rpc_method_handler(
                    servicer.Transcribe,
                    request_deserializer=MLLPStreamingClient_dot_mllp__streaming__pb2.TranscribeRequest.FromString,
                    response_serializer=MLLPStreamingClient_dot_mllp__streaming__pb2.TranscribeResponse.SerializeToString,
            ),
            'AddASRNode': grpc.unary_unary_rpc_method_handler(
                    servicer.AddASRNode,
                    request_deserializer=MLLPStreamingClient_dot_mllp__streaming__pb2.AddASRNodeRequest.FromString,
                    response_serializer=MLLPStreamingClient_dot_mllp__streaming__pb2.AddASRNodeResponse.SerializeToString,
            ),
            'ListASRNodes': grpc.unary_stream_rpc_method_handler(
                    servicer.ListASRNodes,
                    request_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
                    response_serializer=MLLPStreamingClient_dot_mllp__streaming__pb2.ListASRNodesResponse.SerializeToString,
            ),
            'RemoveASRNode': grpc.unary_unary_rpc_method_handler(
                    servicer.RemoveASRNode,
                    request_deserializer=MLLPStreamingClient_dot_mllp__streaming__pb2.RemoveASRNodeRequest.FromString,
                    response_serializer=MLLPStreamingClient_dot_mllp__streaming__pb2.RemoveASRNodeResponse.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'MLLPStreaming', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class MLLPStreaming(object):
    """*
    Logical steps to follow to use the service are:
    <ol>
    <li>Call <i>GetAuthToken</i> with your TTP API credentials to get a valid auth token. This token has to be provided to the rest of rpc methods as metadata with the following header key: "x-mllp-auth-token". </li>
    <li>Call <i>GetTranscribeSystemsInfo</i>, to obtain a list of currently available transcription (ASR) systems.</li>
    <li>Call <i>Transcribe</i> sending a continuous audio stream.</li>
    </ol>
    """

    @staticmethod
    def GetAuthToken(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/MLLPStreaming/GetAuthToken',
            MLLPStreamingClient_dot_mllp__streaming__pb2.AuthTokenRequest.SerializeToString,
            MLLPStreamingClient_dot_mllp__streaming__pb2.AuthTokenResponse.FromString,
            options, channel_credentials,
            call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def GetTranscribeSystemsInfo(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_stream(request, target, '/MLLPStreaming/GetTranscribeSystemsInfo',
            google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
            MLLPStreamingClient_dot_mllp__streaming__pb2.TranscribeSystemsInfoResponse.FromString,
            options, channel_credentials,
            call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Transcribe(request_iterator,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.stream_stream(request_iterator, target, '/MLLPStreaming/Transcribe',
            MLLPStreamingClient_dot_mllp__streaming__pb2.TranscribeRequest.SerializeToString,
            MLLPStreamingClient_dot_mllp__streaming__pb2.TranscribeResponse.FromString,
            options, channel_credentials,
            call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def AddASRNode(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/MLLPStreaming/AddASRNode',
            MLLPStreamingClient_dot_mllp__streaming__pb2.AddASRNodeRequest.SerializeToString,
            MLLPStreamingClient_dot_mllp__streaming__pb2.AddASRNodeResponse.FromString,
            options, channel_credentials,
            call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def ListASRNodes(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_stream(request, target, '/MLLPStreaming/ListASRNodes',
            google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
            MLLPStreamingClient_dot_mllp__streaming__pb2.ListASRNodesResponse.FromString,
            options, channel_credentials,
            call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def RemoveASRNode(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/MLLPStreaming/RemoveASRNode',
            MLLPStreamingClient_dot_mllp__streaming__pb2.RemoveASRNodeRequest.SerializeToString,
            MLLPStreamingClient_dot_mllp__streaming__pb2.RemoveASRNodeResponse.FromString,
            options, channel_credentials,
            call_credentials, compression, wait_for_ready, timeout, metadata)
